/* SPDX-License-Identifier: GPL-2.0-or-later */

/*
 * Copyright (C) 2021 by Nuvoton Technology Corporation
 * Mulin Chao <mlchao@nuvoton.com>
 * Wealian Liao <WHLIAO@nuvoton.com>
 *
 * Copyright (C) 2023 Benjamin VERNOUX 31 Aug 2023 (based on cx32l003_flash.h)
 */
#ifndef OPENOCD_LOADERS_FLASH_CX32L003_CONFIG_H
#define OPENOCD_LOADERS_FLASH_CX32L003_CONFIG_H

/* CX32L003 chip information */
#define CX32L003_FLASH_ERASE_SIZE 512

/* CX32L003 flash loader information */
#define CX32L003_FLASH_LOADER_WORKING_ADDR 0x20000000
#define CX32L003_FLASH_LOADER_PARAMS_ADDR CX32L003_FLASH_LOADER_WORKING_ADDR
#define CX32L003_FLASH_LOADER_PARAMS_SIZE 16
#define CX32L003_FLASH_LOADER_BUFFER_ADDR (CX32L003_FLASH_LOADER_PARAMS_ADDR + CX32L003_FLASH_LOADER_PARAMS_SIZE)
#define CX32L003_FLASH_LOADER_BUFFER_SIZE CX32L003_FLASH_ERASE_SIZE
#define CX32L003_FLASH_LOADER_PROGRAM_ADDR (CX32L003_FLASH_LOADER_BUFFER_ADDR + CX32L003_FLASH_LOADER_BUFFER_SIZE)
#define CX32L003_FLASH_LOADER_PROGRAM_SIZE 3568

/* Stack size in byte. 4 byte size alignment */
#define CX32L003_FLASH_LOADER_STACK_SIZE 512

#endif /* OPENOCD_LOADERS_FLASH_CX32L003_CONFIG_H */
